Overview

About ERBuilder Data Modeler

ERBuilder Data Modeler is a powerful and easy to use visual tool for relational database modeling. It allows the creation and manipulation of database models. The developers at Soft-Builder have put a lot of effort into simplifying this product while ensuring that all the import functionalities required by data modeling professionals are met. Thus, our product not only makes life easier for experienced users. It is also a useful tool for beginners and students.

ERBuilder Data Modeler offers a complete data modeling studio including all features needed to build a data model, here are some main features available in ERBuilder:

● Design and model your database with an easy and user-friendly UI

● Support multiple database systems such as MySQL, Oracle, PostgreSQL, SQLite and MS SQL Server, Azure SQL Database, Amazon Redshift and more

● Validate a model by checking for syntax errors or generate meaningful test data to verify safely your model

● Document and share your model into rich HTML reports

● Forward engineer a model and generate SQL script or database directly

● Reverse engineer existing databases to a model

● Synchronize your database with your model

And more productive features. Visit our website for more details:

https://soft-builder.com/erbuilder-data-modeler/


Installation

To Install ERBuilder first download the installer of the last version from our website.

1- Download ERBuilder installer

2- Run the .exe file

3- Read and accept the End User License Agreement and click Next

4- Choose a location to install ERBuilder and click Next. By default ERBuilder is installed on: “C:\Program Files(x86)\Soft-Builder\ERBuilder”

5- Then click Install to run the installation and wait for ERBuilder to install files

6- When the installation is completed, you can launch ERBuilder by clicking Finish.


End-User License Agreement

Please read this EULA carefully, as it sets out the basis upon which we license the Software for use.

Before you download the Software from our website, we will ask you to give your express agreement to the provisions of this EULA.

By agreeing to be bound by this EULA, you further agree that any person you authorize to use the Software will comply with the provision of this EULA.

1. Definitions

1.1 Except to the extent expressly provided otherwise, in this EULA:

"Documentation" means the documentation for the Software produced by the Licensor and delivered or made available by the Licensor to the User;

"Effective Date" means the date upon which the User gives the User's express consent to this EULA, following the issue of this EULA by the Licensor;

"EULA" means this end user license agreement, including any amendments to this end user license agreement from time to time;

"Force Majeure Event" means an event, or a series of related events, that is outside the reasonable control of the party affected (including failures of the internet or any public telecommunications network, hacker attacks, denial of service attacks, virus or other malicious software attacks or infections, power failures, industrial disputes affecting any third party, changes to the law, disasters, explosions, fires, floods, riots, terrorist attacks, and wars);

"Intellectual Property Rights" means all intellectual property rights wherever in the world, whether registrable or unregistrable, registered or unregistered, including any application or right of application for such rights (and these "intellectual property rights" include copyright and related rights, database rights, confidential information, trade secrets, know-how, business names, trade names, trademarks, service marks, passing off rights, unfair competition rights, patents, petty patents, utility models, semiconductor topography rights and rights in designs);

"Licensor" means Softbuilder, a company incorporated in France;

"Software" means ERBuilder;

"Software Specification" means the specification for the Software set out in the Documentation;

"Source Code" means the Software code in human-readable form or any part of the Software code in human-readable form, including code compiled to create the Software or decompiled from the Software, but excluding interpreted code comprised in the Software;

"Term" means the term of this EULA, commencing in accordance with Clause 2.1 and ending in accordance with Clause 2.2; and

"User" means the person to whom the Licensor grants a right to use the Software under this EULA.

2. Term

2.1 This EULA shall come into force upon the Effective Date.

2.2 This EULA shall continue in force indefinitely, subject to termination in accordance with Clause 8 or any other provision of this EULA.

3. License

3.1 The Licensor hereby grants to the User from the date of supply of the Software to the User until the end of the Term a worldwide, non-exclusive license to:

(a) Install a single instance of the Software;

(b) Use a single instance of the Software in accordance with the Documentation; and

(c) Create, store and maintain up to 3 back-up copies of the Software, subject to the limitations and prohibitions set out and referred to in this Clause 3.

3.2 The User may not sub-license and must not purport to sub-license any rights granted under Clause 3.1 without the prior written consent of the Licensor.

3.3 Save to the extent expressly permitted by this EULA or required by applicable law on a non-excludable basis, any license granted under this Clause 3 shall be subject to the following prohibitions:

(a) The User must not sell, resell, rent, lease, loan, supply, publish, distribute or redistribute the Software;

(b) The User must not alter, edit or adapt the Software; and

(c) The User must not decompile, de-obfuscate or reverse engineer, or attempt to decompile, de-obfuscate or reverse engineer, the Software.

3.4 The User shall be responsible for the security of copies of the Software supplied to the User under this EULA (or created from such copies) and shall use all reasonable endeavors (including all reasonable security measures) to ensure that access to such copies is restricted to persons authorized to use them under this EULA.

4. Source Code

4.1 Nothing in this EULA shall give to the User or any other person any right to access or use the Source Code or constitute any license of the Source Code.

5. No assignment of Intellectual Property Rights

5.1 Nothing in this EULA shall operate to assign or transfer any Intellectual Property Rights from the Licensor to the User, or from the User to the Licensor.

6. Acknowledgments and warranty limitations

6.1 The User acknowledges that complex software is never wholly free from defects, errors, and bugs; and subject to the other provisions of this EULA, the Licensor gives no warranty or representation that the Software will be wholly free from defects, errors, and bugs.

6.2 The User acknowledges that complex software is never entirely free from security vulnerabilities; and subject to the other provisions of this EULA, the Licensor gives no warranty or representation that the Software will be entirely secure.

6.3 The User acknowledges that the Licensor will not provide any legal, financial, accountancy or taxation advice under this EULA or in relation to the Software; and, except to the extent expressly provided otherwise in this EULA, the Licensor does not warrant or represent that the Software or the use of the Software by the User will not give rise to any legal liability on the part of the User or any other person.

7. Limitations and exclusions of liability

7.1 The limitations and exclusions of liability set out in this Clause 7 and elsewhere in this EULA govern all liabilities arising under this EULA or relating to the subject matter of this EULA, including liabilities arising in contract, in tort (including negligence) and for breach of statutory duty, except to the extent expressly provided otherwise in this EULA.

7.2 The Licensor will not be liable to the User in respect of any losses arising out of a Force Majeure Event.

7.3 The Licensor will not be liable to the User in respect of any loss of profits or anticipated savings.

7.4 The Licensor will not be liable to the User in respect of any loss of revenue or income.

7.5 The Licensor will not be liable to the User in respect of any loss of business, contracts or opportunities.

7.6 The Licensor will not be liable to the User in respect of any loss or corruption of any data, database or software.

7.7 The Licensor will not be liable to the User in respect of any special, indirect or consequential loss or damage.

8. Termination

The Licensor may terminate this EULA immediately by giving written notice of termination to the User if:

(a) The User commits any breach of this EULA, or

(b) The User persistently breaches this EULA (irrespective of whether such breaches collectively constitute a material breach).

9. Effects of termination

9.1 Upon the termination of this EULA, all of the provisions of this EULA shall cease to have effect, save that the following provisions of this EULA shall survive and continue to have effect (in accordance with their express terms or otherwise indefinitely): Clauses 1, 3.1, 7, 9, 10 and 11.

9.2 Except to the extent that this EULA expressly provides otherwise, the termination of this EULA shall not affect the accrued rights of either party.

9.3 For the avoidance of doubt, the licenses of the Software in this EULA shall terminate upon the termination of this EULA; and, accordingly, the User must immediately cease to use the Software upon the termination of this EULA.

9.4 Within 10 Business Days following the termination of this EULA, the User must:

(a) Return to the Licensor or dispose of as the Licensor may instruct all media in its possession or control containing the Software; and

(b) Irrevocably delete from all computer systems in its possession or control all copies of the Software.

10. General

10.1 No breach of any provision of this EULA shall be waived except with the express written consent of the party not in breach.

10.2 If any provision of this EULA is determined by any court or other competent authority to be unlawful and/or unenforceable, the other provisions of this EULA will continue in effect. If any unlawful and/or unenforceable provision would be lawful or enforceable if part of it were deleted, that part will be deemed to be deleted, and the rest of the provision will continue in effect (unless that would contradict the clear intention of the parties, in which case the entirety of the relevant provision will be deemed to be deleted).

10.3 This EULA may not be varied except by a written document signed by or on behalf of each of the parties.

10.4 The User hereby agrees that the Licensor may assign the Licensor's contractual rights and obligations under this EULA to any third party. Save to the extent expressly permitted by applicable law, the User must not without the prior written consent of the Licensor assign, transfer or otherwise deal with any of the User's contractual rights or obligations under this EULA.

10.5 This EULA is made for the benefit of the parties and is not intended to benefit any third party or be enforceable by any third party. The rights of the parties to terminate, rescind, or agree any amendment, waiver, variation or settlement under or relating to this EULA are not subject to the consent of any third party.

10.6 This EULA shall constitute the entire agreement between the parties in relation to the subject matter of this EULA, and shall supersede all previous agreements, arrangements, and understandings between the parties in respect of that subject matter.

10.7 This EULA shall be governed by and construed in accordance with French law.

10.8 The courts of France shall have exclusive jurisdiction to adjudicate any dispute arising under or in connection with this EULA.

11. Interpretation

11.1 The Clause headings do not affect the interpretation of this EULA.

11.2 In this EULA, general words shall not be given a restrictive interpretation by reason of being preceded or followed by words indicating a particular class of acts, matters or things.


User interface

ERBuilder has a simple and user-friendly interface, it consists of four main elements:

1. Toolbar located on the top of the main window and contains various buttons to perform some tasks. The toolbar is divided into different sections according to the type of action performed by the button

2. Treeview explorer that enables navigation on the project’s objects

3. Diagram area is the drawing area that displays the elements of the designed model

4. Data model browser is an exploration module build for a full and deep exploration of the data structure extracted from large databases.

5. The status bar displays alerts, errors, and information about the different actions executed


Project Management

Creating a project is the first step after installing ERBuilder Data Modeler, and is as straightforward as it can be. The created project will contain all the tables, relations, domains and data for a database.

Creating a new project

Opening an existing project

Closing a project

Saving a project

Save as a project

Exiting the application

Project properties

Opening multiple projects


Creating a new project

To create a new project:

1. Select “File | New Project” from the menu bar:

2. In the “New Project” dialog box, enter the name of the project, and then select the target DBMS:

Available in: Free, Starter, Standard, Professional and Enterprise Editions


Opening an existing project

To open an existing project:

1. Select “File | Open Project”:

2. In the “File Open” dialog box, select a project (the file extension should be “.ER1” or “.ERB”), and click on “Open”.

The last ten open projects are accessible from the "File | Recent Projects" menu.


Closing a project

To close a project:

1. Select “File | Close Project” on the menu bar.

2. You can also close it with a shortcut (Ctrl+F4):


Saving a project

To save a project:

1. Select “File | Save” on the menu bar.

2. You can also save it with a shortcut (Ctrl+S):


Save as a project

To “Save As” a project:

1. Select “File | Save As” on the menu bar.

2. You can also save it with a shortcut (Ctrl+Alt+S):

3. The Browse window appears. Select the name of a project file to save it.


Exiting the application

To exit the application:

1. Select “File | Exit” on the menu bar.

2. You can also exit with a shortcut (Alt+F4):


Project properties

To display project properties:

1. Select “Project | Project properties”.

2. A window containing two tabs will appear: General and Description. You can enter your project properties and click on OK to confirm.


Opening multiple projects

ERBuilder allows the creation and the manipulation of multiple projects simultaneously; each project is opened on its own window.

To create a new project, while another one is already opened

1. Select “File | New Project” from the menu bar or use the shortcut (Ctrl+N)

2. In the “New Project” dialog box, enter the name of the new project, and then select the target DBMS

3. The new project is opened in the workspace. You can explore all the opened projects and their objects on the treeview panel

The opened projects are totally independent, and cannot share information, except for the Clipboard operations.

To copy/paste tables or relationships between different opened projects:

1. From the source project select table(s) you want to copy (multi-selection is available by mouse drag)

2. Right click to do a copy (or Ctrl+C)

3. Go to the destination project and past the table(s) by doing a right click-> paste (or Ctrl+V)

4. You can rename the copied object(s) on the Past Table window displayed after a past action

You can also drag and drop tables and relationships from a project to another using the treeview or data model browser.

To close a project when you have multiple projects opened:

1. Select the project to close on the treeview

2. From the right of the toolbar, you can close, minimize or maximize the project window

3. Do not forget to save your project before closing it

Available in: Standard, Professional and Enterprise Editions


Diagram Management

Add a new diagram

Delete a diagram

Rename a diagram

Diagram properties

Add tables/relationships to a diagram

Show/hide relationships from a diagram

Export diagram as an image

Print/preview a diagram

Print setup


Add a new diagram

To add a diagram:

1. Right-click on the diagram.

2. Click on “Add Diagram”. A new tab is added with the name “Diagram_ number of the diagram”.

You can also add it with a shortcut (Ctrl+T).


Delete a diagram

To delete a diagram:

1. Right-click on the created diagram.

2. Click on “Delete Diagram”:

You can also delete it with a shortcut (Ctrl+W).


Rename a diagram

To rename a diagram:

1. Right-click on the created diagram.

2. Click “Diagram properties”:

3. On the diagram properties window enter the new name then click on OK.


Diagram properties

To display the diagram properties window, right-click on the diagram name or right-click from the diagram drawing area.

From the diagram properties, you can set the following options:

1. Rename the diagram

2. Display columns level: define which columns will be displayed on the tables on the diagram. You can choose between displaying all columns, primary keys, keys or no columns.

3. Display columns data types: display or hide column data types on the tables in the diagram.

4. Display relationships title: display/hide relationships titles from the diagram.


Add existing tables/relationships to diagram

You can add existing tables or relationships from the other diagrams of the same project to the new diagram by using the “Add tables/relationships” feature.

To add tables/relationships:

1. Right-click on the diagram area of the new diagram and click on “Add tables/relationships”. You can also access to this feature from the main menu “Diagram | Add tables/relationships”.

Otherwise, you can use the “Add tables/relationships” icon from the toolbox

2. On the displayed “Add to diagram window” select the tables/relationships you want to add to your new diagram

3. Click the “Add” button


Show/hide relationships from a diagram

The show/hide relationships utility allows you to show/hide a specific or all relationships from the diagram.

1. To hide a specific relationship, right click on its graphical representation then click on “Hide relationship”.

2. To hide all relationships, go to the menu “Diagram” then click “Show/hide relationships”, or just do a right click on the diagram area, then select “Show/hide relationships”.

3. In the opened window, unselect all relationships to hide them then click “OK”

4. To display one or more relationships, go to “Diagram | Show/hide relationships” then select the relationships you want to show.


Export diagram as an image

To export a diagram as an image:

1. Select “File | Export as Image” from the main menu bar.

2. The Browse window appears. Name the exported image and choose an emplacement to save it then click “Save”.


Print/ Preview a diagram

To print or preview a diagram:

1. Click on “File | Preview/print” or use a shortcut (Ctrl+P):

2. To start printing your diagram, just click on the “Printer” icon.


Print setup

In order to adjust how your diagram will be printed:

1. Click on “File |Page Setup”

In the “Page Setup” window, specify the paper format, orientation and margins.

2. Confirm the changes by clicking “OK”.


Objects

A diagram represents a graphical view of the project. Each project in ERBuilder Data Modeler contains at least one diagram named “All Items”. It automatically contains all created objects (Tables, Relationships, etc.).

Tables

Domains

Columns

Indexes

Constraints

Keys

Triggers

Procedures

Views

Sequences

Relationships

Schemas

Requirements

Manipulate objects


Tables

To access the “Table” management form, double click on its graphical representation in the diagram:


Creating a new table

To create a table in the current project, a simple point-and-click is enough. To do so:

1. Click on “Add Table” in the palette:

2. Then click on the diagram canvas to create the table:

diagram with table added

As a result, a table is created in the “Tables” folder in treeview:


Editing a table

To edit a table, open the “Table” management form by double-clicking on it. In this interface, the table can be renamed and comments can be added. You can also specify the schema associated with this table:

1. You can further add/edit the description of the table by clicking on the “Description” tab:

2. Furthermore, you can also view the DDL script for the current table by clicking on the “Script” tab:

Note that columns, indexes, constraints, keys, triggers, and requirements can be edited in this form. Editing the aforementioned properties is further discussed in the upcoming sections.


Deleting a table

There are three ways to delete a table:

1. Right-click on its diagram graphical representation, and select “Delete”:

2. Select its treeview item, and click on “Delete”.

3. Or select its graphical representation and click on the “Delete” button on the toolbar.


Duplicating a table

To duplicate a table:

1. Right-click on the table.

2. Click on “Duplicate” from the Contextual menu;

You can also duplicate it with a shortcut (Ctrl+U).

3. A Past Table window will appear. Enter the caption and name for the destination table:


Show/hide related relationships

To show or hide all related relationships of an object:

1. Right-click on “Table”.

2. Click on “Hide all related relationships” from the Contextual menu to hide all related relationships to this table, or click “Show all related relationships” to show them.


Table Styles

To change the style or color of a table:

1. Right-click on “Table”.

2. Click on “Styles” from the Contextual menu. You will then see a list of styles:

3. Select a style for the table.

4. You can also customize the font, size, color, and much more by right clicking on the object, then go to “Color/ Font/…”


Domains

To show the “Domains” management dialog box, select “Project | Domains”.

(Please note that domains are not supported by all compatible RDBMSs that ERBuilder Data Modeler is compatible with.)


Creating a new domain

To create a new domain:

1. Select “ [image] ” in the “Domains” management dialog box.

2. Fill in the necessary fields then click on “ [image] ” to save the new domain:


Editing an existing domain

To edit an existing domain:

1. Select “ [image] ” in the “Domains” management dialog box.

2. Once the domain is in edit mode, its name, caption and other domain characteristics can be changed.

3. Click on “ [image] ” to confirm the changes to the domain:


Deleting an existing domain

To delete an existing domain, select “ [image] ” in the “Domains” management dialog box. Note that a confirmation is necessary in the dialog prompt:


Columns

Also called “Attribute” or “Field”, a column is described by a set of parameters. In the “Table” management dialog box, the “Columns” management form is shown by clicking on the “Columns” tab.


Creating a new column

To create a new column for a table:

1. In the “Columns” management tab, click on “ [image] ”:

2. Make sure to apply the changes by clicking on “ [image] ”:

3. Instead of a primitive type, the user can select one of its previously defined Domains (see the previous “Domain” section).

Once the column is in edit mode, you can change its name, caption and other characteristics (see the following table).

Note that the created constraints in the “Columns | Constraints” tab are considered as column constraints. In the generated DDL script, they are defined immediately after their respective column SQL code. By contrast, table constraints are generated after the creation of the entire table (columns and primary keys).


Editing an existing column

To edit an existing column:

1. Click on “ [image] ” in the “Columns” management tab.

2. Make sure to apply the changes by clicking on “ [image] ”:

Once the column is in edit mode, its name, caption and other characteristics can be changed.


Deleting an existing column

To delete an existing column, click on “ [image] ” in the “Columns” management tab. Note that confirmation is necessary for the displayed prompt dialog box:


Indexes

In the “Table” management form, the “Indexes” management interface can be accessed by selecting the “Indexes” tab.


Creating a new index

To create a new index:

1. Click on “ [image] ” in the “Indexes” management tab.

2. Click on “ [image] ” to complete the creation of the new index.

Once the index is in edit mode, the required properties can be edited:


Editing an existing index

To edit an existing index:

1. Select “ [image] ” in the “Indexes” management tab.

2. To apply the changes, click on “ [image] ”:

Once the index is in edit mode, the necessary characteristics can be edited.

Note: Changing the index attributes does not require the index to be in edit mode.


Deleting an existing index

To delete an existing index, click on “ [image] ” in the “Indexes” management tab. Additional confirmation is displayed in a dialog box for applying the changes.


Constraints

SQL implements constraint functionality with a CHECK constraint statement. Basically, constraints restrict the data that can be stored in relations. To show the “Constraints” management form, select the “Constraints” tab in the “Table” management form:


Creating a new constraint

To create a new constraint:

1. Select “ [image] ” in the “Constraints” management tab:

2. To confirm adding the newly created constraint, click on “ [image] ”.


Editing an existing constraint

To edit an existing constraint:

1. Select “ [image] ” in the “Constraints” management tab:

2. To apply the changes, click on “ [image] ”.

Once the constraint is in edit mode, its name, caption and SQL body code can be changed.


Deleting an existing constraint

To delete an existing constraint, simply click on “ [image] “ in the “Constraints” management tab. Note that confirmation is necessary for the dialog box.


Keys

A key can be used to join a non-primary key column in a relationship. Do not confuse the latter with primary keys and foreign keys. More details about the use of keys are shown in the Relationships section. To display the “Keys” management interface, select the “Keys” tab in the “Table” management dialog box:


Creating a new key

To create a new key:

1. Select “ [image] ” in the “Keys” management tab:

2. Select the necessary table columns for the key, and click on “ [image] ”:

add key 2

3. Click on “ [image] ” to confirm the added key:

add key 3

Once the key is in edit mode, its name, caption and columns can be changed.


Editing an existing key

To edit an existing key:

1. Select “ [image] ” in the “Keys” management tab:

2. To change the key attributes, use the back arrow [image] to remove the attribute or the forward arrow [image] to add a new one.

3. Click on “ [image] ” to confirm the changes.

Once the key is in edit mode, its name, caption and columns can be changed.


Deleting an existing key

To delete an existing key, click on “ [image] ” in the “Keys” management tab. A confirmation is required in the prompt dialog box.


Triggers

To show the “Triggers” management interface, select the “Triggers” tab in the “Table” management dialog box:


Creating a new trigger

To create a new trigger:

1. Select “ [image] ” in the “Triggers” tab.

2. Click on “ [image] ” to apply this change:


Editing an existing trigger

To edit an existing trigger:

1. Select “ [image] ” in the “Triggers” management tab:

2. Click on “ [image] ” to apply this change.

Once the trigger is in edit mode, its name, caption and SQL body code can be changed.


Deleting an existing trigger

To delete an existing trigger, click on “ [image] ” in the “Triggers” management tab. A confirmation dialog box is displayed to complete the removal of the trigger.


Procedures

To show the “Procedures” management dialog box, select “Project | Procedures” from the main screen.


Creating a new procedure

To create a new procedure:

1. Select “ [image] ” in the “Procedures” management dialog box.

2. Click on “ [image] ” to save the procedure:

Once the procedure is in edit mode, its name, caption and body SQL script can be changed. Please note that ERBuilder Data Modeler does not parse the SQL code.


Editing an existing procedure

To edit an existing procedure:

1. Select “ [image] ” in the “Procedures” management dialog box.

2. Click on “ [image] ” to save the changes:

Once the procedure is in edit mode, its name, caption and body SQL script can be changed.


Deleting an existing procedure

To delete an existing procedure, select “ [image] ” in the “Procedures” management form. Note that confirmation is necessary for the prompt dialog box:


Views

To access the “Views” management dialog box, select “Project | Views”.


Creating a new view

To create a new view:

1. Select “ [image] ” in the “Views” management dialog box:

2. Click “ [image] ” to confirm the added view.

Once the view is in edit mode, its name, caption and SQL script body can be changed.


Editing an existing view

To edit an existing view:

1. Select “ [image] ” in the “Views” management dialog box:

2. Click on “ [image] ” to confirm the changes.

Once the view is in edit mode, its name, caption and body SQL script can be changed. Note that ERBuilder Data Modeler does not parse the SQL code.


Deleting an existing view

To delete an existing view, Select “ [image] ” in the “Views” management dialog box. To confirm the deletion of the view, click on “Yes” in the resulting prompt dialog box.


Sequences

A sequence (also called a “generator” in Firebird) is a stored variable containing a shared value for different tables and data. Sequences generally serve to implement the current auto-increment values in databases tables. To show the “Sequences” management dialog box, select “Project | Sequences”.

Note that sequences are not supported by all the RDBMSs compatible with ERBuilder Data Modeler. For example, MySQL does not support sequences, whereas Firebird does.


Creating a new sequence

To create a new sequence:

1. Select “ [image] ” in the “Sequences” management dialog box:

2. Click on “ [image] ” to confirm the added view.

Once the sequence is in edit mode, its caption (and eventually its name) and necessary parameters according to the used RDBMS (see the following table) can be specified.

The previous table lists which sequence characteristics are supported by the RDBMS compatible with ERBuilder Data Modeler. The following table gives a brief explanation for the possible sequence characteristics:

Sequence characteristics | Type | Possible values | Description
Seed | Integer | An integer | The start value of the sequence
Increment | Integer | An integer | The step value of the sequence
Maximum value | Integer | An integer | The upper limit for the possible sequence values
Minimal value | Integer | An integer | The lower limit for the possible sequence values
Cycle | Enumerate | “Cycle”, “No Cycle” | Specifies if the sequence comes back to the lower limit value after reaching the upper limit value.
Cache | Enumerate | “Cache”, “No Cache” | Specifies if the RDBMS is going to store a limited number of the next sequence values in cache for quicker access (cache size must not be null).
Integer type | Enumerate | “TINYINT”, “SMALLINT”, “INT”, “BIGINT”, “DECIMAL”, “NUMERIC” | Specify the sequence type.
Order | Enumerate | “Order”, “No Order” | Specify if the RDBMS is going to generate the sequence values in natural order (useful in a Real-time Application Cluster).


Editing an existing sequence

To edit an existing sequence:

1. Select “ [image] ” in the “Sequences” management dialog box:

2. Click on “ [image] ” to confirm the sequence modifications.

Once the sequence is in edit mode, its caption (and eventually its name) and necessary parameters according to the used RDBMS can be specified.


Deleting an existing sequence

To delete an existing sequence, select “ [image] ” in the “Sequences” management dialog box. Note that a subsequent confirmation is necessary for the prompt dialog box.


Relationships

Also noted as “Relation”, “Association” or “Reference”, this represents the association between pairs of tables. ERBuilder Data Modeler supports four kinds of relationships: Identifying relationship, Non-identifying relationship, many-to-many relationship, and reflexive relationship. To show the “Relation” management dialog box, double click on the relation in the diagram or click right on the relation and select “Properties”.

Note that creating a relation from the treeview is not possible. It is possible only through point-and-click.


Creating a new relationship

On ERBuilder Data Modeler, you can create relationships between two tables or between a table and itself by linking the parent table to the child table. To add a new relationship:

1. From the toolbox, select one of the available relationships icons:

· Identifying relationships

· Non-identifying relationships

· Many to many relationships

2. Click on the parent table symbol in the diagram canvas:

3. Hold the mouse click and drag the cursor to the child table:

This is how a simple relationship is displayed:

The result is the added arrow captioned “Reference_1” and the inclusion of the “Parent_ID” attribute in the “Child Table”.

By contrast, a many-to-many relationship is displayed as follows:

The result is the creation of “Reference_1” and “Reference_2” arrows and the inclusion of “Parent_ID” and “Child_ID” attributes in the new “Relation Table (Table2)”.

Available in: Free, Starter, Standard, Professional and Enterprise Editions

As for reflexive relationships, you can create these types of relationships by right-clicking on the table and selecting “Reflexive Relationship” from the menu.

The result is the appearance of a “Reference_1” reflexive arrow in the diagram and the “Parent_ID_1” attribute creation in the table “Parent Table”.

reflexive relation ex

Available in: Free(Only one relationship per table), Starter, Standard, Professional and Enterprise Editions


Editing an existing relationship

To edit an existing relationship:

1. Double click on the corresponding graphical representation:

2. Or right-click on the relation, and select “Properties”:

Once the relationship is in edit mode, its name, caption and the other relationship characteristics can be changed.

Here are the characteristics you can edit for a relationship:

Characteristic | Tab | Description
Description | General | A brief textual description of the relationship
Parent Key | Joins | The unique parent table or primary key of the relationship
Child Name | Joins | The child table attribute to reference the parent key
Constraint Name | Options | A name for the constraint
On parent Update | Options | Specify if the RDBMS updates the child table reference attribute value once the parent key is updated
On parent Delete | Options | Specify if the RDBMS deletes the child table rows corresponding to a newly deleted parent key value
Notes | Notes | Brief textual notes

*Note that editing the generated SQL script is not possible.


Deleting an existing relationship

To delete a relationship:

1. Either select the matching treeview item and click on the “Delete” key:

2. Or right-click on the corresponding graphical representation (arrow), and select “Delete Relation”:

Note that confirmation is necessary for the prompt dialog box.


Autolink Relations

You can transform a simple relation to auto-link. To do so:

Right-click a relationship symbol in a diagram and click on “AutoLink”.


Split or merge relationships

● You can split a relationship in a diagram by simply right-clicking on a relationship, clicking “Split”, and then dragging the created split point to adjust the relationship line.

Split Merge right click relationship Split Merge split relationship Split Merge move point

● To merge a split relationship, right-click on the relationship and then click “Merge”.

Available in: Standard, Professional and Enterprise Editions


Schemas

To access the “Schemas” management dialog box, select “Project | Schemas”.


Creating a new schema

To create a new schema:

1. Select “ [image] ” in the “Schema” management dialog box. Once the schema is in edit mode, its name and caption can be specified

2. Click the “ [image] ” button to save the new schema:


Editing an existing schema

To edit an existing schema:

1. Select “ [image] ” in the “Schema” management dialog box. Once the domain is in edit mode, its name and caption can be changed.

2. Click on “ [image] ” to confirm the changes to the schema:


Deleting an existing schema

To delete an existing schema, select “ [image] ” in the “Schemas” management dialog box. Note that confirmation is necessary for the prompt dialog box.


Requirements

To show the list of all requirements, navigate to the menu “Project | requirements”.

1. Create a new requirement

2. Assign a requirement

3. Edit a requirement

4. Delete a requirement

Available in: Enterprise Edition


Creating a new requirement

To create a new requirement, go to “Project | Requirement” from the main menu. In the opened window, click on the “Add” button to start creating a new requirement.

Fill in the following:

1. ID: filled automatically by ERBuilder Data Modeler

2. Code: enter a code for the new requirement

3. Title: enter a title for the new requirement

4. Date: pick a date for the requirement created

5. Source: fill in the source of your requirement

6. Risk: define the requirement risk level (Undefined, high, medium, low)

7. Category: assign a category for the requirement

8. Description: describe the new requirement

Click the “Apply” button to save your entries, then click on “OK”.

Available in: Enterprise Edition


Assign a requirement

To assign a requirement to a table, navigate to the appropriate tab and then add the table you want to associate with this requirement. To add a table, select it, and then click on the right arrow to add it as shown in the following screenshot:

In the same way, you can assign this requirement to columns, triggers, constraints, relationships and procedures.

There is another way to associate a requirement to a specific object. Open the management form of the object that you want to add to it a requirement.

Navigate to the “Requirement” tab then from there you can add multiple requirements.

Available in: Enterprise Edition


Editing an existing requirement

To edit an existing requirement:

1. Open the requirements window, by going to “Project | Requirements”

2. From the left list of the requirements, select the requirement you want to edit then click on “ [image] ”.

3. Click on “ [image] ” to confirm the changes to the requirement.

Available in: Enterprise Edition


Deleting an existing requirement

To delete an existing requirement:

1. Open the “Requirement” window by going to “Project | Requirements”.

2. Select the requirement you want to delete and then click on the “Delete” button.

3. Note that confirmation is necessary for the displayed prompt dialog box.

Available in: Enterprise Edition


Manipulate objects

Undo/Redo an action

Copying/Pasting objects

Reaching objects

Finding/Replacing objects

Replacing data types


Undo/Redo an action

You can undo or redo many actions in ERBuilder. You can undo changes, even after you have saved your project, and then save again.

- To undo an action:

1. Select “Edit | Undo” from the menu bar:

Note that you can also undo an action by clicking on the “Undo” icon from the toolbar:

You can also Undo with a shortcut (CTRL+Z), press repeatedly if you want to undo multiple actions.

- To redo an action you have undone:

1. Select “Edit | Redo” from the menu bar:

Note that you can also redo an action by clicking on the “Redo” icon from the toolbar:

You can also redo with a shortcut (CTRL+Y).

Available in: Free(Only two levels), Starter, Standard, Professional and Enterprise Editions


Copying/Pasting objects

- To copy an object:

1. Right-click on the object.

2. Select “Copy” from the Contextual menu:

Note that you can also copy it with a shortcut (Ctrl+C). Another way to copy an object is to select it, and click on the “Copy” icon from the toolbar:

- To paste the selected object:

1. Right-click on Diagram.

2. Select “Paste” from the Contextual menu:

You can also paste it with a shortcut (Ctrl+V). Another way to paste is to click on the “Paste” icon from the toolbar:

If you copy a table, a window paste table appears. To enter a caption and a name for the destination table:

paste table window

Available in: Free(Only for a single table), Starter, Standard, Professional and Enterprise Editions


Reaching objects

To reach an object:

  1. Right-click on treeview items such as Tables or Relationships:

If there is one diagram, the table will be selected in this diagram. If there are multiple diagrams, a list will be displayed containing all diagrams in which this table exists. You will need to select one of these diagrams to display this diagram with the selected table.

reach in diagrams

Available in: Starter, Standard, Professional and Enterprise Editions


Finding/Replacing objects

- To find an object:

  1. Select “Tools | Find” from the menu bar:

You can also use a shortcut (Ctrl+F).

  2. A window will appear which contains a field to enter the word you are looking for, with the ability to choose between two options (Case sensitive or whole word) and also to select the objects you want to search from a treeview.

  3. When you click on “Search”, a list will appear. It contains the objects that include this word.

found items console

- To replace an object:

  1. Select “Tools | Replace ” from the menu bar:

You can also use a shortcut (Ctrl+H).

  2. A window will appear. You can enter:

- The word you are looking for

- The word that will replace the searched word

You have also the ability to choose between two options (case sensitive or whole word). You can also select the which objects you want to search from a treeview.

  3. When you click on “Search”, a list will appear in the same window which contains the objects including the search word. After that, select the object(s) you want to replace and click on “Replace”.

Available in: Starter, Standard, Professional and Enterprise Editions


Replacing data types

You can convert all data types of all columns of a model. To replace data types, select “Tools | Replace data type”.

Select the data type to change, then select the target data type. Depending on the selected data type, you can specify its size, scale or expression.

You can also convert data types specified in domains by clicking on “replace data type in domain” or “Replace domain by data type in column”.

Available in: Starter, Standard, Professional and Enterprise Editions


Connections management

ERBuilder data modeler allows you to create multiple connections with multiple DBMS. ERBuilder supports the most popular DBMS such as Oracle, MySQL, Microsoft SQL Server, PostgreSQL, Azure SQL Database, Amazon Redshift, SQLite and Firebird.

Creating a new connection

Editing an existing connection

Deleting an existing connection

SSL settings

Windows Authentication


Creating a new connection

To create a new connection:

  1. Select “File | Manage connections”.

  2. Then, click “ [image] ” in the “Manage Connections” form:

manage connections window

  3. Fill in the required fields for a database connection:

manage connections add

  4. Click on “ [image] ” to complete this process.

manage connections valider

Available in: Starter, Standard, Professional and Enterprise Editions


Editing an existing connection

To modify the properties of an existing connection:

  1. Select “File | Manage connections”:

  2. Select the connection that requires editing, and click on “ [image] ” in the “Manage Connections” form:

  3. Change the necessary properties of the connection:

manage connections edit2

  4. And finally, click on “ [image] ” to apply the changes:

manage connections valider after edit

Available in: Starter, Standard, Professional and Enterprise Editions


Deleting an existing connection

To delete an existing connection:

  1. Select “File | Manage connections”:

  2. Select the connection you want to delete then click on “ [image] ”:

3. To complete the deletion, click “Yes” in the dialog box:

Available in: Starter, Standard, Professional and Enterprise Editions


SSL settings

In order to adjust the SSL setting, you can open the "SSL" tab in the "Manage Connections" window when creating or modifying a connection. Then you can:

1. Specify connection settings such as certificate, key, certificate authority and encryption algorithm.

2. Click on “validate” and then “OK”.

Available in: Starter, Standard, Professional and Enterprise Editions


Windows Authentication

During the creation of a new connection to an MS SQL Server database, you can set one of the two authentication methods:

● SQL server authentication

1. Choose ”Server” authentication method

2. Fill in the user name and the password of your database

● Windows authentication

If you use windows authentication as the default authentication method in your SQL Server, then choose “Windows” while creating a new connection to your SQL Server database.

Available in: Starter, Standard, Professional and Enterprise Editions


Forward/Reverse engineering

Forward engineering

Reverse engineering


Forward engineering

With this feature, ERBuilder allows you to forward engineer your model to generate DDL SQL scripts to create your database directly.

Model validation

DDL Script generation

Database generation


Model validation

ERBuilder Data Modeler offers the ability to check for potential mistakes and ambiguities in the created model. To validate a project:

1. Select “Tools | Check Model”:

2. In the console, errors and warnings are displayed:

3. Double click on any line in the console to go directly to the form where the error is detected:


DDL Script generation

Generally, a data modeling project is created to eventually generate the database reflecting the model. For this, ERBuilder Data Modeler provides a feature to generate the “DDL” script for creating the designed database in the selected project’s DBMS. To generate the project Data Definition Language script:

  1. Select “Tools | Generate DDL Script”:

  2. Check the “Save to file” checkbox and enter the Directory Path and File Name:

  3. Click on “Generate DDL Script”:

generate ddl button

Available in: Starter, Standard, Professional and Enterprise Editions


Database generation

Note that for MySQL, PostgreSQL and Firebird, directly creating a database is possible.

1. Select “Generate Database” from the “Database” menu:

2. Select “Connection name”:

3. Click on “Connect”

4. Choose the connection options, and click on “Generate Database”:

Available in: Starter, Standard, Professional and Enterprise Editions


Reverse engineering an existing database

ERBuilder data modeler allows you to reverse engineer an existing database to create its data model. You have the ability to reverse engineer a local or a remote database.

To reverse engineer an existing database:

1. Select “File | Reverse Engineer” from the main menu:

2. In the “Reverse Engineering” dialog box, select a local or remote connection and click on “Next”. You can also create a new connection by clicking the “new connection” button (see the section Connections Management .)

2. In the next step, select the items to be imported (Tables, Views, Procedures, and Sequences), then click on “Import”:

In the console below, the process will display a notification regarding the success or failure of the database items import.

- Tables and relationships are positioned on the diagram.

Available in: Standard, Professional and Enterprise Editions


Others advanced tools

Assign Data Generator settings

ERBuilder provides multiple generators for creating virtual test data in the database sandbox or generating data directly to populate a connected database.

  1. First, open the “Table” form by double-clicking on the table graphic. In this interface, go to the “Columns” tab. At the top right of this screen, go to the “Data generation” tab.

  2. In this tab, you can assign a data generator for each column. The following generators are available:

● Constant value: Generates a constant value for the selected column.

● Dictionary: Allows you to create different values for the selected column. You can use an existing data dictionary or add a new one. To add a new data dictionary, see the section “Add a new data dictionary” .

● Random generate: Generates random data between the minimum and maximum value that you specify.

● Random via a mask: Generates random values structured according to a mask.

● Sequence generate: Generates a sequence from the start value to the finish value that you specify. You can also set a step value; otherwise, the step value will be automatically set to 1. Notice that when the data type is DATE, the step value is defined in terms of days, weeks, months, or years. This generator is recommended for all auto-increment or serial data types.

● Set null: Sets all column values to null.

Available in: Professional and Enterprise Editions


Add a new dictionary

ERBuilder allows you to create a dictionary generator that can be used in the Data Generation feature to fill the values of a column having a string data type.

To add a new dictionary, follow these steps:

  1. Open the table form by double-clicking on the table graphic. Under the “Columns” tab, navigate to the “Data generation” tab on the right of the screen.
  2. On the left, select a column that has a string data type. Then, on the right, select the generator “Dictionary”. Click on [image] to add a new dictionary.

  3. Browse to your data file (*.txt) and open it, and then select the category of your new dictionary or create a new category. Last, name your dictionary, and click the “Add” button.

Note: The dictionary file to load must be a text file (*.txt), and the values must be separated by line breaks.

Available in: Professional and Enterprise Editions


Generate test data

ERBuilder provides a way to generate data to populate your database directly. It is recommended to save a copy of the database that you are going to fill with data.

  1. First, navigate to “Tools” > “Generate Test Data”.
  2. In the Data Generation window, you have the choice to generate data from:

● Database sandbox: The virtual test data generated in the database sandbox will be inserted into the database. To use this option, you must already have virtual test data filled in. (See the section “Work with virtual test data in a database sandbox”.)

● Generators: ERBuilder will generate data by using the generator specified previously (see the section “Assign Data Generator settings” ). In this case, you need to set the default number of rows to generate.

  3. Select a connection to the database, and click “Connect” to test it. If the connection is successful, you can click the “Next” button; otherwise, review your connection configuration by navigating to “File” > “Manage Connections” (or [Ctrl+Alt+c]). (See the section “Connections Management”).

In this window, select the tables that you want to generate, and click the “Start” button.

When the data generation is finished, you can check to see whether the data were successfully inserted into your database by going to the console page under the diagram area.

Note:

● For certain data types, the only generator possible is “Set null”, which means that the generation of these data types is not supported.

● For columns with an auto-increment or sequence data type (for example, SERIAL in PostgreSQL or auto-increment in MySQL), data generation will not be possible because of the nature of these data types. The DBMS will automatically generate these data.

● In the case of a reflexive relationship and a primary key with an auto-increment or sequence data type, the generated data for the foreign key will be set to null.

Available in: Professional (Up to 10.000 rows per table)

and Enterprise Editions (Unlimited rows per table)


Work with virtual test data in a database sandbox

Virtual test data are data that are not persistent in a database. These data are stored only in memory and are used to:

– Validate a data model by manipulating and querying the data in a database sandbox.

– Generate test data.

● To fill in virtual test data: You can fill in virtual test data manually, or you can populate the grid automatically using the data generators (see the section “Assign Data Generator settings” ).

– To populate the virtual test data grid automatically:

1. Open the “Database sandbox” form by clicking on “Tools | Database sandbox”. On the “Data” tab select the column that you want to fill in with virtual data. You need to set the number of rows that you want to populate in the grid.

2. Then, click the populate button [image] .

You can delete all populated data by clicking the delete button [image]. You can also add, edit, or delete a single row.

– To populate the virtual test data grid manually:

Use the toolbar buttons to manually fill in the grid. You can also edit or delete an existing row.

Note: If you fill in data manually, be careful when the data type is serial or auto-increment; you need to respect the sequencing rule. If you insert random data, an issue can arise when you generate persistent data from the virtual data to populate your database.

● To view virtual test data:

You can display the data as a grid or as a form. To switch the view, click the Grid View button [image] or the Form View button [image] at the bottom.

Button | Description
 | Add record: Fill in a new record manually.
 | Delete record: Delete any selected record(s).
 | Edit records: Edit an existing record.
 | Apply changes: Apply the changes made to a record.
 | Discard changes: Cancel all edits made to a record.
 | Set the number of rows: Set the number of rows that you want to populate in the grid.
 | Populate the grid: Populate the grid using the data generators.
 | Clear the grid: Clear all existing data in the grid.
 | First record: Move to the first record.
 | Last record: Move to the last record.
 | Next record: Move to the next record.
 | Previous record: Move to the previous record.
 | Grid view: Switch to grid view.
 | Form view: Switch to form view.
 | Export to CSV: Export the virtual data generated to a CSV file.
 | Import from CSV: Import virtual data from a CSV file.

● To query virtual test data:

You can manipulate virtual test data by using the query tool, accessed by clicking the “Query” tab.

Use the toolbar buttons to do the following:

Button | Description
 | Open a saved SQL query
 | Save an SQL query
 | Execute an SQL query
 | Navigate to the previous query
 | Navigate to the next query
 | First record: Move to the first record.
 | Last record: Move to the last record.
 | Next record: Move to the next record.
 | Previous record: Move to the previous record.

Available in: Professional and Enterprise Editions


Compare models and/or databases

Using the comparison feature of ERBuilder data modeler, you can compare:

– An open model with another model.

– An open model with a database.

– A database with another database.

Note: Models and databases to be compared must have the same DBMS and the same DBMS version.

1. First, choose the type of comparison:

● Model/Model comparison

To compare two data models, follow these steps:

1) On the main menu, navigate to “Tools | Compare”.

2) In the “Compare” window, you must now select the target data model. Click the Browse button [image], and load the target data model file “*.ERB”.

Note: The source model is the open project.

● Model/Database comparison

To compare an open model with a database, follow these steps:

1) On the main menu, navigate to “Tools” > “Compare”.

2) Select a connection to your database, and click “Connect”.

Note: The connection to the database must be created and configured from “Database” > “Manage Connections”. See the section “Connections Management”.

● Database/Database comparison

To compare two databases, follow these steps:

1) On the main menu, navigate to “Tools” > “Compare”.

2) Select the source and target databases to compare.

2. Now, use the compare options to select the object(s) to compare: Schemas, Views, Domains, Constraints, Tables, Procedures, Triggers, Diagrams, Relationships, Sequences, Indexes, Keys, ignore case, and requirements. By default, all objects are selected.

3. Click the “Next” button to start the comparison process. When the comparison is finished, the differences will appear in the result window grouped by object.

In the result list, objects that are the same are marked with an equal icon [image] .

Objects that are different are marked with a warning icon [image].

An [image] icon designates an object in the source model that does not exist in the target model.

An [image] icon designates an object that is missing in the target model and existing in the source model.

The table below the comparison tree view shows more detail on the selected object and shows the differences in the selected object between the two models compared.

Note: If you work with a DBMS which supports schemas and your model do not have a schema associated with all your objects, to have a reliable comparison result you have to:

-  Create a new schema on ERBuilder which match with the default schema of the DBMS you work with. Example: schema Public on PostgreSQL.

-  Associate on ERBuilder all your objects with the schema created previously.

4. You can generate an HTML comparison report by clicking “Generate Report”.

Available in: Standard, Professional and Enterprise Editions


Generate change script

ERBuilder provides a schema-database synchronization feature that allows you to compare your model with an existing database, see the differences between their structures and generate a synchronization SQL script.

To synchronize your database with your model follows these steps:

1. Select “Tools | Generate change script” from the main menu

Select a connection to your target database, and click “Connect” to test the connection.

Note: The connection to the database must be created and configured from “File” > “Manage Connections”. See the section “Connections Management” for more details.

2. Choose the object(s) to include in the comparison and synchronization process from the section “compare options”. By default, all objects are selected.

3. Click the “Next” button to start the comparison process. When the comparison is finished, the differences will appear in the result window grouped by objects.

4. Now, you can click the “Generate Change Script” button to generate the synchronization DDL script.

Available in: Standard, Professional and Enterprise Editions


Update model from database

The Update from Database utility allows you to update a data model with changes made to the database.

To synchronize your model with your database follows these steps:

1. Select “Tools | Update model from database” from the main menu

2. Select a connection to your target database, and click “Connect” to test the connection.

Note: The database connection must be made and configured under "File | Manage Connections". For further information, see the section “Connections Management”.

3. Select the object(s) to include in the comparison and synchronization operation from the "compare options" section. All objects are chosen by default.

4. To begin the comparison, click the “Next” button. When the comparison is complete, the differences will be displayed in the result window, ordered by object.

5. Click the “update model” button to start synchronizing your data model with the database.

6. Note that the wizard will only update the model with objects that have been created or changed in the database. If an object is removed from the database, the wizard will not delete the entities that relate to it from the model. In this case, you must manually delete the entities.

Available in: Standard, Professional and Enterprise Editions


Merge models

During a data modeling lifecycle, a team of data modelers can build independent parts of the same data model and then need to merge those parts together. ERBuilder data modeler integrates the possibility of merging two independent data models.

To merge two ERBuilder data models:

1. Open the left model with ERBuilder then navigate to the main menu and click “Tool | Merge models”.

2. Now, choose the right data model file “*.ERB”, select it and click Open.

3. In the “compare options” section, you can select which objects can be included in the comparison process.

4. To initiate the comparison process, click “Next” and then the differences window opens.

5. Select the objects you want to merge then click “Update model” button.

If you select to merge an object that exists in the current project and not in the second project, this object will be removed from the merged project.

If you select to merge an object that exists in the second project and not in the current project, this object will be added to the merged project. Note that if the object selected is a table or relationship, then this object will be added only on the treeview (it will not appear on the diagram area).

If you select an object that exists in both projects but with differences, then this object will be updated in the merged project.

Available in: Standard, Professional and Enterprise Editions


Data model browser

The main purpose of the Data model browser module is to allow a full exploration of the data structure extracted from your database.

The Data Model browser form can be displayed by clicking on the “Data model browser” button on the top right of the workspace area.

By default the “Data model browser” is in floating mode, the form is displayed by hovering over the “Data model browser” button. Otherwise, you can pin the browser form on the right of the workspace by clicking the “pin button “.

To Unpin the browser form and return to the default mode, you can use the “unpin button “.


Elements of the data model browser

The Previous/Next buttons allow the navigation up and down on your exploration process.

Search and select a table to explore.

Open the table details form to edit the selected table.

Access to the database sandbox form for generating virtual test data.

The number of related ‘parents’ tables.

The number of related ‘child’ tables.

The ‘display objects’ filter allows you to show in the grid all tables, parent and child, parent, or child tables.

The search box allows you to find and select any table in the grid.

Displays a form allowing for more flexible search capabilities. Read how to use the advanced search form .

Allows you to reset and clear all the filters entered.

The tables grid

To explore a specific table, right click on that table name and click on "Explore". You can also open the “Table” details form by double-clicking on it.

To access the database sandbox form and generate virtual test data for a specific table, right click on this table and select “Database sandbox”.

On opening the browser form, by default all the model’s tables are listed in the grid.

For each table, the following fields are displayed:

· Table Caption

· The number of related parent tables.

· The number of related child tables.

· Table Name

· Description

· Comment

· Schema Name

In order to build your ER diagrams in an interactive way, it is possible to drag and drop tables from the tables grid to the Diagram area.

The area below the grid is composed of two tabs, which are “Relationships” and “In diagram” tab.

· Relationships tab: All the relationships between the table to explore and the selected table are displayed in this list. Double click on the relationship’s name to open the “Relationship” details form.

· In diagram tab: all the diagrams where the selected table exists are displayed in this list. Double click on the diagram’s name to select the related table on this “diagram”.

· Expand the “data model browser” form: ERBuilder data modeler allows you to expand the data model browser form to take the full width of the window. To do so, click the expand button on the left bottom of the browser form.

To reset the display to default, click on the left bottom of the browser form.

· Hide objects in diagram: by checking the “Hide objects in diagram” checkbox, the tables present in the current diagram are not displayed in the tables grid.

Available in: Professional and Enterprise Editions


Using the advanced filters

The advanced search feature allows more flexible search capabilities. The advanced search form consists of two sections:

· The Left section includes a range of filters fields, including table caption, schema name, parent count, child count, description and comment. This section is divided into two tabs, the “All” tab which contain the filter fields and the “Searched” tab that contain all the filters applied for this search.

Field Order: allows you to order the fields by logical or alphabetic order.

· The right section is also divided into two tabs; the “By Value” tab allows you to enter the field value that can be searched by exact match, partial match at beginning, or partial match anywhere. The second tab “By Range” allows a search by range value for the specified field in the left section.

View summary: The “view Summary” button displays a summary of the filters applied to a search.

New search: The “New Search” button allows you to reset and clear all the filters entered.

Available in: Enterprise Edition


Model documentation

To generate Model Documentation:

1. Select “Tools | Generate Model Documentation” on the menu bar:

You can also click on the icon from the toolbar:

Available in: Free(Basic documentation), Starter, Standard, Professional and Enterprise Editions

2. A setting window will appear, containing three tabs:

● General: In this tab, you will need to:

-   Select a Directory to save the model documentation.

-   You can check the Images Diagram to embed the diagram model image into the model documentation.

-   Select diagrams to include in the model documentation generated.

● Elements to include: This part consists of checking the elements of the treeview composed of Tables, Columns, Views, Procedures, Sequences, Domains, Relationships, etc. and their own fields. If you check these elements, the model documentation will include a table with their fields and their values.

● Elements detail to include: This part is similar to the Previews part. You just need to check elements of tables and columns with their fields to detail them. The documentation model will contain a table with fields and values for each table and column.

● You can check all elements of treeview with the checkbox in the top right:

● You can uncheck all elements of treeview with the checkbox in the top right:

● You can save your model documentation settings to reuse them later in another project.

To save settings:

1. Click on the “Save Settings” button, and name your settings file (*.CFG)

To load previously saved settings:

1. Click on the “Load Settings” button, browse to your file (*.CFG) and open it.

Available in: Starter, Standard, Professional and Enterprise Editions


Generate data dictionary

To generate a Data dictionary

  1. Select “Tools | Generate Data Dictionary” from the Tools menu.

  2. Select the following options as needed and then click OK.

· Output

Select a Directory to save the data dictionary.

· Export type

Lets you specify the format of the generated data dictionary document. Available format are HTML and CSV.

· Fields to export

Lets you specify the fields to export.

It is possible to search and filter in the generated data dictionary. It is also possible to export the document in XML, JSON, CSV, SQL, TXT, and MS-EXCEL format.

Available in: Professional and Enterprise Editions


Generate user interface

ERBuilder allows you to generate a web user interface for your model.

  3. First, open the “Table” form by double-clicking on the table graphic. In this interface, go to the “Field User Interface” tab.

In this tab, you need to specify the following:

● An HTML field definition for each column of your table. Here are the input types you can use:

Textfield | Defines a one-line text input field.
Textarea | Defines a multi-line text input field.
Checkbox | Lets the user select ZERO OR MORE options from a limited number of choices.
Radio | Lets the user select ONLY ONE of a limited number of choices.
Email | Defines an input field that should contain an email address.
Select | Creates a drop-down list. Define the available options in the list value, separated by line breaks.
List | Defines an editable list.
File | Defines a file-select field and creates a “Browse” button for file uploads.
Image | Lets the user upload an image file.
Date | Defines an input field that should be a date.
Datetime | Defines an input field that should include the year, month, day, and time.
Time | Defines an input field that should be a time.
Number | Defines a numeric input field.

● Visibility options. You can set the view type in which this column will be displayed. The available options are:

– Grid view: Displays the column in the record list page.

– Detail view: Displays the column in the details page.

– Add view: Displays the column in the insert form page.

– Edit view: Displays the column in the update form page.

● Validation options. In this section, you can specify one or more validation options for each column, such as Required input or Read-only. Other options available are Max length, Help text, Min value, Max value, HTML Pattern, Width and Height of the input field.

  4. Navigate to “Tools | Generate User Interface”.

  5. Once the “Generate User Interface” window is displayed, you can choose between a dark theme and a white theme. You can also specify the output folder. By default, the output folder will be your current project folder.

  6. Open the generated user interface with a web browser.

Home interface

Grid view for the selected table

Detail view

Add an entry view

Available in: Enterprise Edition


Change DBMS

ERBuilder data modeler allows you to change the data model from one DBMS to another.

  1. To change the DBMS of an opened project, navigate to “Tools” > “Change DBMS”.

  2. In the “Change DBMS” window, choose the target DBMS, and then click “OK”.
  3. Once the change is done, you will see the new DBMS on the status bar under the diagram area.

Available in: Professional and Enterprise Editions


Git version control

The Git version control is a feature that enables you to work with Git for storing and sharing versioned data models. It provides a robust and easy way for collaboration and team working during the modeling process.

1. Setup Git with ERBuilder data modeler

2. Import project from Git repository

3. Save changes to Git repository

4. Refresh model

5. Manage versions

Available in: Enterprise Edition


Setup of Git with ERBuilder Data Modeler

Before you start setting up a connection between ERBuilder data modeler and Git, you need to:

- Install Git on your computer;

- Have an account on Git;

- Create a working repository and grant access to all the collaborators on your project.

To set-up a connection with your repository on Git, open ERBuilder data modeler then navigate to “Repository | Manage repository” and fill in the following information:

· Remote repository: set path to your Git repository. To get the remote repository path, log in your Git account then navigate to the repository. Go to the “Code” dropdown button and open it, then copy the Https path.

· Email: fill in your email

· Name: fill in the Git user name

· Git client: set path to your Git client

· Branch: if you use the default branch “Master” leave this field empty.
Otherwise, if you are using another branch, mention it here.

Available in: Enterprise Edition


Import project from Git repository

To import and open a project from Git repository, go to “Repository | Import” then specify an empty directory on your computer to save your project.

Available in: Enterprise Edition


Save changes to Git repository

To commit and push changes to Git repository, go to “Repository | Save”.

ERBuilder will compare and display the differences between the current version of your data model and the remote version.

In the merge window, you can save all the modification that you made into the remote repository by selecting the appropriate changes then clicking “Save to repository”.

Once you click “Save to repository”, a window will appear in which you have to enter a commit message for this version of your model.

After entering the appropriate commit message, click “OK” to commit the saving operation. ERBuilder data modeler will display a message on successful saving operation; otherwise, an error message will be displayed with the error encountered.

Available in: Enterprise Edition


Refresh model

The refresh feature allows you to update your local data model with the last changes made by other collaborators.

To refresh your model, go to “Repository | Refresh” from the main menu. ERBuilder data modeler will display the merge window with the differences between your local model and the last saved version. To refresh your local model and merge it with the remote model, check the changes you want to add to your local model then click on “Update model”.

Available in: Enterprise Edition


Manage versions

To display the multiple versions committed by the different collaborators of your data-modeling project, navigate to “Repository” from the main menu and click “versions”.

A list of all the commits will be displayed with the details about each one (Hash, author name, author email, commit date, and the commit message).

Available in: Enterprise Edition

Compare with versions

To compare your current data model with any of the listed versions, just select the version you want to compare with then click on the “Compare” button.

A comparison window will appear with all the differences found. You can generate a report of this comparison and open it with your favorite web navigator.

Available in: Enterprise Edition

Merge with versions

You have the ability to merge the current model with one of the committed version by selecting the concerned version then click on “Merge”.

On the merge screen, ERBuilder for Salesforce will show you the differences between your current model and the selected version. Select the objects you want to include to the merge operation the click on “Update model”.

Available in: Enterprise Edition

Open a version

In addition, to the comparison and the merge of versions functionalities, you can also open a specific version as a new project from the list of the committed versions.

To do that, select the version you want to open then click on “Open”. When you click on “open”, you will be invited to specify a new empty folder to save the new project.

Available in: Enterprise Edition


Versions management

ERBuilder offers an indexed and integrated archiving system. To archive a project:

1. Click on “File | Manage Versions”:

2. In the “Archive Version” window, click on “Archive”:

3. Specify a name and a comment for the version:

4. Click on “OK”.

Available in: Standard, Professional and Enterprise Editions


Options management

A number of options are available for customizing your project. The options window is accessed via “Tools | Options”:

To access the Options window:

  1. Click in the icon from the toolbar:

  2. A window will appear which contains four tabs. Each one has a specific option:


General tab

This tab contains two sections: Display and Environment

● Display: In this section, you can choose a theme from the list of themes:

You can also change the style of the icons (Flat or Classic) as well as their size (32x32 or 16x16):

● Environment: In this section, you can load the last project you worked on upon launching the software. You can also change the working directory by opening a file and opening a dialog box to select the directory. You also have the option to change the default DBMS by selecting a DBMS from the list:


Diagram tab

In this section, you can change the background color of a diagram and display table shadows in a diagram by checking a checkbox:

Diagram notation: You can choose between four possible notations: Relational, IDEF1X, Conceptual (Crow’s foot) and CODASYL. To do so:

1. Go to “diagram notation” by clicking on “Tools | Options | Diagrams”.

2. Choose your favorite notation from the “Diagram Notation” combo box.

Show grid: Check this option to show/hide the grid in the diagram area.

Snap to grid: Align objects created in the diagram area to the grid.


Tables tab

In this section, you can change the properties of a table:

● Display Column Level: You can change the properties of the columns to display in the tables by selecting the following values: All attributes, Primary keys, Keys, No attributes.

● Auto size: To adjust the size with the table contents in the diagram, check the Auto size tables option.

● Display data types: To display data types in the tables, check the Display data types option.

● Auto edit after creation: When you check this option, you will have the ability to display the window table automatically after you drag and drop the table in the diagram.

● Default title font: To change the title style of the table in the diagram, click on the table_1 button to display a window that contains a list of fonts, sizes, styles, effects, colors, and scripts.

● Default body font: To change the styles of the attributes table displayed in the diagram, click on the ID INTEGER button to display a window containing a list of fonts, sizes, styles, effects, colors, and scripts.

● Default title background color: This option allows you to change the color of the table header title in the diagram by selecting a color from the window displayed after clicking on the button:

● Default body background-color: This option allows you to change the color of the table body in the diagram by selecting a color from the window displayed after clicking on the button:

● Inserts: This option allows you to change the date format and the date separator.


Relationships tab

In this section, you can change the properties of relationships:

● Displaying information: You can select the title of the relationship to display it in the diagram. The title values to display include Caption, Name, and Constraint Name.

● Displaying title: To display the relationship name in the diagram, check the “Display Title” option.

● Moving referenced parent column properties to the child referencing column: All constraints (default, not null, character set collate) of the referenced parent column are automatically applied to the child referencing column.

● Auto reuse columns: If the parent and child table contain a common field, i.e. one having the same name, type, and characteristics, this field is automatically associated with the foreign key constraint, provided that the latter is not already referenced in another foreign key constraint.

● Default color: You can change the color of the relationship by clicking on the button and selecting the color: